PROGRAM PROBA;

TYPE
      STRING255=STRING[255];
VAR
      BUFFER:ARRAY[1..432] OF BYTE;
      VIDEO:STRING[6];
      COMM_STR : STRING255;
      I,J,OFFSET:INTEGER;
PROCEDURE GRAF_OFF(CHANNEL:BYTE);
BEGIN
  INLINE($3A/CHANNEL/$F7/$03/$DB/$B2/$08/$AF/$3D/$D3/$B2/$2A/
         $F4/$BF/$11/$10/$00/$19/$EB/$21/BUFFER/$01/$B0/$01/
         $ED/$B0/$08/$D3/$B2);
END;{OFF}

PROCEDURE GRAF_ON(CHANNEL:BYTE;MODE,COLOR,X_SIZE,Y_SIZE:INTEGER);
BEGIN
  VIDEO:='VIDEO:';
  INLINE($DB/$B2/$08/$AF/$3D/$D3/$B2/$2A/$F4/$BF/$11/$10/$00/
         $19/$11/BUFFER/$01/$B0/$01/$ED/$B0/$08/$D3/$B2/$3A/
         MODE/$57/$06/$01/$0E/$16/$F7/$10/$3A/COLOR/$57/
         $06/$01/$0E/$17/$F7/$10/$3A/X_SIZE/$57/$06/$01/$0E/
         $18/$F7/$10/$3A/Y_SIZE/$57/$06/$01/$0E/$19/$F7/$10/
         $3A/CHANNEL/$F5/$F7/$03/$F1/$11/VIDEO/$F7/$01);
END;{ON}

PROCEDURE DISPLAY(CHANNEL:BYTE;SAT,SFROM,STO:INTEGER);
BEGIN
  INLINE($21/CHANNEL/$7E/$21/SAT/$5E/$21/SFROM/$4E/$21/STO/
         $56/$06/$01/$F7/$0B);
END;

PROCEDURE PRINT(CHANNEL:BYTE;SZOVEG:STRING255);
BEGIN
  INLINE($3A/CHANNEL/$21/SZOVEG/$4E/$06/$00/$23/$EB/$F7/$08);
END;

PROCEDURE PLOT(CHANNEL:BYTE;X,Y:INTEGER);
BEGIN
  PRINT (CHANNEL,#27+'A'+CHR(LO(X))+CHR(HI(X))+CHR(LO(Y))+CHR(HI(Y)));
END;

PROCEDURE BEAM(CHANNEL:BYTE;ON_OFF:INTEGER);
BEGIN
  PRINT(CHANNEL,#27+CHR(ORD('s')-(ON_OFF*32)));
END;


PROCEDURE DRAW(CHANNEL:BYTE;X1,Y1,X2,Y2:INTEGER);
BEGIN
  BEAM(CHANNEL,0);
  PLOT(CHANNEL,X1,Y1);
  BEAM(CHANNEL,1);
  PLOT(CHANNEL,X2,Y2);
END;

PROCEDURE BOX(CHANNEL:BYTE;X1,Y1,X2,Y2:INTEGER);
BEGIN
  BEAM(CHANNEL,0);
  PLOT(CHANNEL,X1,Y1);
  BEAM(CHANNEL,1);
  PLOT(CHANNEL,X2,Y1);
  PLOT(CHANNEL,X2,Y2);
  PLOT(CHANNEL,X1,Y2);
  PLOT(CHANNEL,X1,Y1);
END;

PROCEDURE ELLIPSE(CHANNEL:BYTE;X,Y:INTEGER);
BEGIN
  PRINT(CHANNEL,#27+'E'+CHR(LO(X))+CHR(HI(X))+CHR(LO(Y))+CHR(HI(Y)));
END;

PROCEDURE SET_INK(CHANNEL:BYTE;COLOR:INTEGER);
BEGIN
  PRINT(CHANNEL,#27+'I'+CHR(COLOR));
END;

PROCEDURE FILL(CHANNEL:BYTE);
BEGIN
  PRINT(CHANNEL,#27+'F');
END;

BEGIN
  PORT[$BF]:=$0C;
  CLRSCR;
  WRITELN('MINDEN Ok!');
  GRAF_ON(1,1,2,42,27);
  DISPLAY(1,1,1,27);
  FOR I:= 1 TO 130 DO
  BEGIN
    J:=RANDOM(256);
    SET_INK(1,J);
    BOX(1,RANDOM(1344),RANDOM(1344),RANDOM(1344),RANDOM(1344));
  END;
  WHILE NOT KEYPRESSED DO;
  PRINT(1,#26);
  FOR I:=0 TO 130 DO
  BEGIN
    J:=RANDOM(256);
    SET_INK(1,J);
    PLOT(1,RANDOM(1344),RANDOM(972));
    ELLIPSE(1,RANDOM(640),RANDOM(640));
    FILL(1);
  END;
  GOTOXY(20,21);CLREOL;
  WRITELN('Ok');
  WHILE NOT KEYPRESSED DO;
  GRAF_OFF(1);
END.
