PROGRAM Text_File_Service;

{   Program designed and written by:  - sabolc - 1989

    Dedicated to: Jakab Ferenc & Halasz Kalman

    Special thanks to:

            - Borland International for the TURBO Pascal;
            - DENBY (C) for guide and help                   }



CONST ii:CHAR=#137;  { az ekezetes betuk }
      oo:CHAR=#159;
      oe:CHAR=#134;
      uu:CHAR=#149;
      ue:CHAR=#128;

TYPE str160=STRING[160];
      fname=STRING[14];

VAR b,c,d,e,h,l,a,f:BYTE;  { Z80 regs }
                 bc:INTEGER ABSOLUTE c;
                 de:INTEGER ABSOLUTE e;
                 hl:INTEGER ABSOLUTE l;
                 af:INTEGER ABSOLUTE f;
            command:str160;
                 ch:CHAR;
                  w:ARRAY [1..24] OF STRING[80];
 epr,magyar:BOOLEAN;
                res:INTEGER;
                n1,n2:fname;
                f1,f2:TEXT;
                equ:ARRAY [0..255] OF CHAR;

{$I SYS.OVL}

PROCEDURE wrs(s1,s2:str160);
{ a magyar valtozo erteketol fuggoen magyarul v. angolul ir ki }
BEGIN
  IF magyar THEN write(s2)
            ELSE write(s1);
END;

PROCEDURE upc(VAR n:fname);
{ nagybetusit egy filenevet }
VAR i:INTEGER;
BEGIN
  FOR i:=1 TO length(n) DO n[i]:=upcase(n[i]);
END;

FUNCTION menu(db,be,le,elt:INTEGER):INTEGER;
{ megfelelo parameterezes mellett kirak egy 1-24 elemu menut a kepernyore,
  majd a valasztott erteknek megfelelo szammal ter vissza }
VAR    vege:BOOLEAN;
    i,j,k,l:INTEGER;
          c:CHAR;

  PROCEDURE rak;
  { kurzorpozicionalas }
  BEGIN
    gotoxy(be+4,j+le);
  END;

BEGIN
  clrscr;
  k:=24 DIV db; j:=1-k; { k lesz a sorkoz a kepernyon }
  FOR i:=1 TO db DO  { a szovegek kiirasa }
    BEGIN
      j:=j+k;
      gotoxy(be,j+le); write(i+elt:3,'.');
      gotoxy(be+6,j+le); write(w[i]);
    END;
  i:=(db DIV 2)+1; j:=1+i*k-k; { a kurzor kozepre kerul }
  vege:=FALSE; rak;
  REPEAT
    read(kbd,c); l:=ord(c);
    CASE l OF
    32,13:BEGIN menu:=i; vege:=TRUE END; { ha valasztott }
       30:IF i>1 THEN BEGIN rak; i:=i-1; j:=j-k; rak END;   { JOY FEL }
       31:IF i<db THEN BEGIN rak; i:=i+1; j:=j+k; rak END;  { JOY LE  }
      177:BEGIN rak; i:=1; j:=1; rak END;            { SHIFT + }
      181:BEGIN rak; i:=db; j:=1+(i-1)*k; rak END;   {  JOY    }
          END;
  UNTIL vege;
END;

PROCEDURE mmfill;
{ a fomenut generalja; a foprogramban is lehetne, csak igy attekinthetobb }
BEGIN
  IF magyar THEN
    BEGIN
      w[1]:='File nyomtat`sa';
      w[2]:='File sz{tdarabol`sa';
      w[3]:='File-ok |sszeforraszt`sa';
      w[4]:='B`rmilyen transzform`l`s';
      w[5]:='Transzform`l`s DCD  ==> HUN:';
      w[6]:='Transzform`l`s HUN: ==> DCD';
      w[7]:='[kezetlen'+ii+'t{s DCD-b'+oe+'l';
      w[8]:='[kezetlen'+ii+'t{s HUN:-b'+oo+'l';
      w[9]:='EXOS parancs';
      w[10]:='V{ge'
    END
            ELSE
    BEGIN
      w[1]:='Print a file';
      w[2]:='Cut up a file';
      w[3]:='Stick files together';
      w[4]:='Transform any to any';
      w[5]:='Transform DCD  ==> HUN:';
      w[6]:='Transform HUN: ==> DCD';
      w[7]:='Clear accents from DCD';
      w[8]:='Clear accents from HUN:';
      w[9]:='EXOS command';
      w[10]:='Quit'
    END
END;

FUNCTION Opf:BOOLEAN;
{ megnyit egy forras- es egy celfile-t; a durva hibakat ki is vedi;
  TRUE, ha sikeres volt, kulonben FALSE }
VAR i:INTEGER;
    ch:CHAR;
BEGIN
  Opf:=TRUE;
  clrscr; nl;
  wrs('Input file: ','Forr`sfile: '); readln(n1);
  upc(n1);
  assign(f1,n1);  {$I-}
  reset(f1);
  IF IOResult<>0 THEN { ha nem tudja megnyitni }
    BEGIN
      nl; write(n1:14,' ');
      wrs('was not found.','nincs meg.'); nl; delay(1000);
      Opf:=FALSE
    END
                 ELSE
    BEGIN
      nl; wrs('Output file: ','C{lfile: '); readln(n2); nl;
      upc(n2);
      assign(f2,n2);
      reset(f2);
      IF IOResult=0 THEN { ha mar letezik }
        BEGIN
          nl; write(n2:14,' ');
          wrs('already exists. Overwrite it (Y/N) ?',
              'm`r l{tezik. Fel}l'+ii+'rjuk (I/N) ?');
          read(kbd,ch);
          IF ch IN ['y','Y','i','I'] THEN { ha felulirjuk }
            BEGIN
              erase(f2);
              rewrite(f2);
            END
                                     ELSE { ha nem }
            BEGIN
              close(f1); close(f2);
              Opf:=FALSE;
            END
        END
                    ELSE
          rewrite(f2);
    END;
  {$I+}
END;

PROCEDURE transform;
{ az equ[] tomb beallitott ertekei alapjan atalakitja a file-t }
VAR i,lnum:INTEGER;
     s1,s2:STRING[200];
BEGIN
  IF Opf THEN { igy hivja meg Opf-t, hisz az fuggveny !!! }
    BEGIN
      lnum:=0;
      nl;
      write(lnum:5);
      wrs(' lines transformed. ',' sor transzform`lva.'); bsp(20);
      WHILE NOT eof(f1) DO
        BEGIN
          readln(f1,s1);
          s2:='';
          FOR i:=1 TO length(s1) DO s2:=s2+equ[ord(s1[i])];
          writeln(f2,s2);
          lnum:=lnum+1;
          bsp(5);
          write(lnum:5);
        END;
      close(f1); close(f2);
    END;
END;

FUNCTION onename(n:fname;q:INTEGER):fname;
{ a .001, .002, stb. file-okhoz generalja ezt a kiterjesztest }
VAR i:INTEGER;
   xx:STRING[10];
BEGIN
  str(q,xx); n:=n+'.';
  FOR i:=1 TO 3-length(xx) DO n:=n+'0';
  n:=n+xx;
  onename:=n;
END;

PROCEDURE cut;
{ egy file feldarabol`sa }
VAR linenum,i,j:INTEGER;
    s:str160;
BEGIN
  clrscr; nl;
  wrs('The file to be cut up: ','A felv`gand'+oo+' file: ');
  readln(n1); upc(n1);
  {$I-}
  assign(f1,n1);
  reset(f1);
  IF IOResult<>0 THEN
    BEGIN
      nl;
      write(n1:14,' ');
      wrs('was not found.','nincs meg.'); nl;
    END
                 ELSE
    BEGIN
      nl; wrs('Destination files will be named like name.001; name.002, etc.',
          'A c{lfile-ok nevei n{v.001; n{v.002, stb. alak'+uu+'ak lesznek.');
      nl; wrs('All existing files with such names will be destroyed.',
              'Az |ssszes ilyen nev'+ue+' l{tez'+oe+' file t|rl'+oe+'dik.');
      nl; nl; wrs('So type the name of the destination file group: ',
                  'Teh`t a c{lfile-csoport neve: ');
      REPEAT
        readln(n2); upc(n2);
      UNTIL pos('.',n2)=0;
      nl; wrs('Number of lines one part should consist: ',
              'Az egy r{szbe ker}l'+oe+' sorok sz`ma: ');
      REPEAT
        readln(linenum);
      UNTIL linenum>0;
      i:=1; j:=1; assign(f2,onename(n2,1)); rewrite(f2);
      WHILE NOT eof(f1) DO
        BEGIN
          readln(f1,s); writeln(f2,s); j:=j+1;
          IF j>linenum THEN
            BEGIN
              close(f2); write(onename(n2,i):14,' ');
              wrs('is ready. Starting ','k{sz. Kezd'+oe+'dik ');
              j:=1; i:=i+1;
              assign(f2,onename(n2,i));
              writeln(onename(n2,i):14);
              rewrite(f2);
            END;
        END;
      close(f2); close(f1);
    END;
  {$I+}
END;

PROCEDURE stick;
{ file-ok osszeragaszt`sa }
VAR stend:BOOLEAN;
    s:STRING[200];
    j:INTEGER;

  PROCEDURE stf;
  { hasonlo, mint az mmfill }
  BEGIN
    IF magyar THEN
      BEGIN
        w[1]:='B`rmilyen sz|vegfile-ok |sszeragaszt`sa';
        w[2]:='Ezzel a programmal darabolt file-ok ragaszt`sa';
        w[3]:='V{ge eme r{sznek'
      END
              ELSE
      BEGIN
        w[1]:='Stick any kind of files together';
        w[2]:='Stick together files cut up by this program';
        w[3]:='Quit this part';
      END;
  END;

  FUNCTION f2open:BOOLEAN;
  { szinten egy filenyitogato fuggveny }
  BEGIN
    f2open:=TRUE;
    clrscr; nl;
    wrs('Here first you have to give the TARGET file name: ',
        'Most el'+oe+'sz|r a C[Lfile nev{t kell megadnod: ');
    readln(n2);
      upc(n2);
      assign(f2,n2);
      {$I-}
      reset(f2);
      IF IOResult=0 THEN
        BEGIN
          nl;
          write(n2:14,' ');
          wrs('already exists. Overwrite it (Y/N) ?',
              'm`r l{tezik. Fel}l'+ii+'rjuk (I/N) ?');
          read(kbd,ch);
          IF ch IN ['y','Y','i','I'] THEN
            BEGIN
              erase(f2);
              rewrite(f2);
            END
                                     ELSE
            BEGIN
              close(f2);
              f2open:=FALSE;
            END;
        END
                     ELSE
        rewrite(f2);
        {$I+}
  END;

  PROCEDURE stany;
  { akarmilyen file-ok osszeragasztasa }
  VAR stae:BOOLEAN;
  BEGIN
    IF f2open THEN
      BEGIN
    wrs('Now you have to give all the files to be sticked together,',
        'Most meg kell adnod az |sszes |sszeragasztand'+oo+' file nev{t'); nl;
    wrs('one by one. After the last one just hit <ENTER>.',
        'egyes{vel. Az utols'+oo+' ut`n }ss <ENTER>-t.'); nl; nl;
    j:=1;
    REPEAT
      write(j:3,'. file: '); readln(n1);
      stae:=n1='';
      IF NOT stae THEN
        BEGIN
          upc(n1); assign(f1,n1);
          {$I-}
          reset(f1);
          IF IOResult<>0 THEN
            BEGIN
              nl; write(n1:14,' ');
             wrs('not found. Give another name or hit <ENTER> to stop.',
          'nincs meg. Adj '+uu+'j nevet, vagy }ss <ENTER>-t, hogy befejezd.');
              nl; nl;
            END
                         ELSE
            BEGIN
              WHILE NOT eof(f1) DO
                BEGIN
                  readln(f1,s); writeln(f2,s);
                END;
              close(f1);
              nl; write(n1:14,' ');
              wrs('is sticked to ','hozz`ragasztva ');
              write(n2:14);
              wrs(' .','-hoz/hez/h|z.'); nl; nl;
              j:=j+1;
            END;
          {$I+}
        END
                  ELSE
        IF j>1 THEN close(f2);
    UNTIL stae;
    END;
  END;

  PROCEDURE stth;
  { a sajat maga altal darabolt file-ok ragasztasa }
  VAR i,from,tto:INTEGER;
  BEGIN
    IF f2open THEN
      BEGIN
        nl; wrs('Source files must be named like name.001; name.002, etc.',
 'A  forr`sfile-ok nevei n{v.001; n{v.002, stb. alak'+uu+'ak kell legyenek.');
      nl; nl; wrs('So type the name of the source file group: ',
                  'Teh`t a forr`sfile-csoport neve: ');
      REPEAT
        readln(n1); upc(n1);
      UNTIL pos('.',n1)=0;
      REPEAT
        wrs('From: ','Mett'+oe+'l: '); readln(from);
        wrs('To: ','Meddig: '); readln(tto);
      UNTIL tto-from>=0; { nehogy mar ilyennel ki tudjak akasztani }
      FOR i:=from TO tto DO
        BEGIN
          assign(f1,onename(n1,i));
          {$I-}
          reset(f1);
          IF IOResult<>0 THEN
            BEGIN
              nl; write(onename(n1,i):14,' ');
              wrs('not found - not sticked.','nincs meg - kimarad.'); {$I+}
            END
                         ELSE
            BEGIN  {$I+}
              WHILE NOT eof(f1) DO
                BEGIN
                  readln(f1,s); writeln(f2,s);
                END;
              close(f1);
              nl; write(onename(n1,i):14,' ');
              wrs('is sticked to ','hozz`ragaszt'+oo+'dott ');
              write(n2:14); wrs(' .','-hoz/hez/h|z.'); nl;
            END;
        END;
      close(f2);
    END;
  END;

BEGIN
{ a ragasztos resz foprogramja }
  stend:=TRUE;
  WHILE stend DO
    BEGIN
      stf;
      res:=menu(3,10,3,0);
      CASE res OF
        1:stany;
        2:stth;
        3:stend:=FALSE;
        END; { of CASE }
    END;
END;

PROCEDURE clequ;
{ az equ[] tombot alapertekekre allitja }
VAR i:INTEGER;
BEGIN
  FOR i:=0 TO 255 DO equ[i]:=chr(i);
END;

PROCEDURE trany;
{ transzformalas konfiguracios file alapjan }
VAR i,j:INTEGER;
BEGIN
  clrscr; nl;
  wrs('Transformation base file: ',
      'A transzform`ci'+oo+'s alap file: ');
  readln(n1); upc(n1);
  IF pos('.',n1)=0 THEN n1:=n1+'.CHG';
  {$I-}
  assign(f1,n1);
  reset(f1);
  IF IOResult<>0 THEN
    BEGIN
      nl;
      write(n1:14,' ');
      wrs('was not found.','nincs meg.'); nl;
    END
                 ELSE
    BEGIN
      clequ;
      WHILE NOT eof(f1) DO
        BEGIN
          {$I-}
          read(f1,i);
          IF IOResult<>0 THEN
            BEGIN
              nl; wrs('Error in .CHG file structure',
                       'Hiba a .CHG file szerkezet{ben');
              delay(1000); exit;
            END;
          {$I+}
          REPEAT
            read(f1,ch);
          UNTIL ch='=';
          {$I-}
          read(f1,j);
          IF IOResult<>0 THEN
            BEGIN
              nl; wrs('Error in .CHG file structure',
                       'Hiba a .CHG file szerkezet{ben');
              delay(1000); exit;
            END;
          {$I+}
          write('CHR(',i:3,') = CHR(',j:3,')');
          bsp(19);
          equ[i]:=chr(j);
          REPEAT
            readln(f1);
          UNTIL eof(f1) OR NOT eoln(f1);
        END;
        close(f1);
      nl; nl; wrs('Transformation base accepted',
                  'A transzform`ci'+oo+'s alap rendben');
      delay(500);
      transform;
    END;
END;

{ a most kovetkezo procedurak teljesen hasonloak:
  mindegyik beallitja valahogyan az equ[] tombot, majd meghivja a
  transform procedurat }

PROCEDURE dcd_hun;
BEGIN
  clequ;
  equ[064]:=#128; equ[091]:=#129; equ[158]:=#131; equ[092]:=#132;
  equ[135]:=#133; equ[150]:=#134; equ[093]:=#135; equ[144]:=#136;
  equ[153]:=#130; equ[096]:=#144; equ[123]:=#145; equ[159]:=#147;
  equ[124]:=#148; equ[134]:=#149; equ[149]:=#150; equ[125]:=#151;
  equ[128]:=#152; equ[137]:=#153; equ[129]:=#064; equ[130]:=#093;
  equ[131]:=#091; equ[132]:=#123; equ[136]:=#125; equ[139]:=#096;
  equ[154]:=#124; equ[156]:=#092;
  transform;
END;

PROCEDURE hun_dcd;
BEGIN
  clequ;
  equ[128]:='@'; equ[129]:='['; equ[130]:=#153; equ[131]:=#158;
  equ[132]:='\'; equ[133]:=#135; equ[134]:=#150; equ[135]:=']';
  equ[136]:=#144; equ[144]:='`'; equ[145]:='{'; equ[146]:=#137;
  equ[147]:=#159; equ[148]:=#124; equ[149]:=#134; equ[150]:=#149;
  equ[151]:='}'; equ[152]:=#128; equ[064]:=#129; equ[093]:=#130;
  equ[091]:=#131; equ[123]:=#132; equ[125]:=#136; equ[096]:=#139;
  equ[124]:=#154; equ[092]:=#156;
  transform;
END;

PROCEDURE cl_dcd;
BEGIN
  clequ;
  equ[064]:='A'; equ[091]:='E'; equ[158]:='O'; equ[092]:='O';
  equ[135]:='O'; equ[150]:='U'; equ[093]:='U'; equ[144]:='U';
  equ[153]:='I'; equ[096]:='a'; equ[123]:='e'; equ[159]:='o';
  equ[124]:='o'; equ[134]:='o'; equ[149]:='u'; equ[125]:='u';
  equ[128]:='u'; equ[137]:='i'; equ[129]:=#064; equ[130]:=#093;
  equ[131]:=#091; equ[132]:=#123; equ[136]:=#125; equ[139]:=#096;
  equ[154]:=#124; equ[156]:=#092;
  transform;
END;

PROCEDURE cl_hun;
BEGIN
  clequ;
  equ[128]:='A'; equ[129]:='E'; equ[130]:='I'; equ[131]:='O';
  equ[132]:='O'; equ[133]:='O'; equ[134]:='U'; equ[135]:='U';
  equ[136]:='U'; equ[144]:='a'; equ[145]:='e'; equ[146]:='i';
  equ[147]:='o'; equ[148]:='o'; equ[149]:='o'; equ[150]:='u';
  equ[151]:='u'; equ[152]:='u';
  transform;
END;

PROCEDURE ex_com;
{ EXOS-parancsok kiadasa }
VAR ee:BOOLEAN;
        xx:STRING[40];
BEGIN
  clrscr; ee:=FALSE; nl; nl;
  wrs('You can type any EXOS string but to avoid system crash do not type',
      'B`rmilyen parancsot kiadhatsz, de hogy a rendszer ne sz`lljon el,');
  nl;
  wrs('commands that change the system: do not run other programs, do not',
  'ne adj ki olyan parancsot, amely v`ltoztat a rendszeren: ne ind'+ii+'ts');
  nl;
  wrs('clear files, etc.','el m`s programokat, ne t|r|lj, stb.'); nl; nl;
  wrs('To stop simply hit <ENTER>.','Kil{pni az <ENTER>-rel lehet.'); nl; nl;
  REPEAT
    write('>'); readln(xx);
    IF xx='' THEN ee:=TRUE;
    IF NOT ee THEN
      BEGIN
        command:=xx;
        DOS_com;
      END;
  UNTIL ee;
END;

{$I PRINT.OVL}

BEGIN { of main program }
  epr:=FALSE;
  write(#27,'y4English/Magyar (E/M) ?'); read(kbd,ch);
  { nemi elokeszuletek, alahuzas-kurzor }
  magyar:=ch IN ['m','M'];
  IF magyar THEN BEGIN
                   command:='var 90 off';
                   DOS_com;
                 END ELSE
                 BEGIN
                   b:=4; a:=205;
                   exos(11);
                 END;
  Cdf; { karakterdefinialas }
  IF magyar THEN stlin('Sz|vegfile-szerviz 2.0  ')
            ELSE stlin('Text File Service v2.0  ');
  REPEAT
    mmfill;
    res:=menu(10,25,3,0);
    CASE res OF
      1: praf;
      2: cut;
      3: stick;
      4: trany;
      5: dcd_hun;
      6: hun_dcd;
      7: cl_dcd;
      8: cl_hun;
      9: ex_com;
      10: epr:=TRUE;
      END; { of CASE }
  UNTIL epr;
  write(#27,'x4'); clrscr; { visszaallitja a teglalap-kurzort }
END.